package insurance.action;

import insurance.form.LoginForm;
import insurance.logic.Login;

import java.io.IOException;

import javax.servlet.ServletException;
import javax.servlet.http.HttpServletRequest;
import javax.servlet.http.HttpServletResponse;
import javax.servlet.http.HttpSession;

import org.apache.struts.action.Action;
import org.apache.struts.action.ActionForm;
import org.apache.struts.action.ActionForward;
import org.apache.struts.action.ActionMapping;
import org.apache.struts.action.ActionMessage;
import org.apache.struts.action.ActionMessages;
import org.seasar.framework.container.S2Container;
import org.seasar.framework.container.factory.S2ContainerFactory;

/**
 * OCActionNX
 */
public class LoginAction extends Action {

    /**
     * OCANV̎s
     *
     * @param mapping ANV}bsO
     * @param actionForm ANVtH[
     * @param request HTTPNGXg
     * @param response HTTPX|X
     * @return forward ANVtH[h
     *
     * @exception IOException o͗O
     * @exception ServletException T[ubgO
     */
    public ActionForward execute( ActionMapping mapping, ActionForm form,
        HttpServletRequest request,HttpServletResponse response)
        throws IOException, ServletException {

        ActionForward forward = null;
        ActionMessages messages = null;
        HttpSession session = null;
        LoginForm loginform = null;
        Login login = null;
        boolean bRet = false;

        try {

            loginform = (LoginForm)form;

            //SeasarɂLoginCX^X̎擾
            S2Container container = S2ContainerFactory.create("logic.dicon");
            login = (Login)container.getComponent("login");
            bRet = login.execute(loginform.getUserId(),loginform.getPassword());

            if (!bRet) {

                messages = new ActionMessages();
                messages.add(ActionMessages.GLOBAL_MESSAGE,
                   new ActionMessage("error.login.password"));
                saveErrors(request, messages);

                return new ActionForward(mapping.getInput());

            }

            // [UZbVɐݒ
            session = request.getSession();
            session.setAttribute("userId",loginform.getUserId());
            session.setAttribute("userName",login.getUserName());
            session.setAttribute("insuranceClass",login.getInsuranceClass());
            session.setAttribute("userType",login.getUserType());

            forward = mapping.findForward("success");

        } catch ( Exception ex ) {
            forward = mapping.findForward("fatalerror");
        }

        return forward;

    }

}
