import org.seasar.framework.container.S2Container;
import org.seasar.framework.container.factory.S2ContainerFactory;

public class UserConstructorInjectionClient {

    public static final String PATH = "UserConstructorInjection.dicon";

    public static void main(String[] args) {
        S2Container container = S2ContainerFactory.create(PATH);

        //  cc@
        User user = (User)container.getComponent(User.class);
        System.out.println(user.getName());
        System.out.println(user.getAddress());

        //  ccA
        User user2 = (User)container.getComponent("user");
        System.out.println(user2.getName());
        System.out.println(user2.getAddress());

    }
}
